VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsApplication"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"clsInstance"
Attribute VB_Ext_KEY = "Member0" ,"clsInstance"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private mstrDisplayText         As String
Private mstrWindowTitle         As String
Private mstrClassName           As String
Private mcolInstances           As Collection
Private mobjLastInstance      As clsInstance
Private mobjPreviousInstance    As clsInstance

Public Property Let DisplayText(ByVal strDisplayText As String)
    mstrDisplayText = strDisplayText
End Property

Public Property Get DisplayText() As String
    DisplayText = mstrDisplayText
End Property

Public Property Let WindowTitle(ByVal strWindowTitle As String)
    mstrWindowTitle = strWindowTitle
End Property

Public Property Get WindowTitle() As String
    WindowTitle = mstrWindowTitle
End Property

Public Property Let ClassName(ByVal strClassName As String)
    mstrClassName = strClassName
End Property

Public Property Get ClassName() As String
    ClassName = mstrClassName
End Property

Public Function AddInstance(ByVal lngHwnd As Long) As clsInstance
    On Error Resume Next
    Dim objInstance     As clsInstance
    Set objInstance = New clsInstance
    objInstance.hWnd = lngHwnd
    mcolInstances.Add objInstance, "_" & lngHwnd
    If Err.Number Then
        Set AddInstance = Instance(lngHwnd)
    Else
        Set AddInstance = objInstance
    End If
    Set mobjPreviousInstance = mobjLastInstance
    Set mobjLastInstance = objInstance
    Set objInstance = Nothing
End Function

Public Property Get LastInstance() As clsInstance
    Set LastInstance = mobjLastInstance
End Property

Public Property Get PreviousInstance() As clsInstance
    Set PreviousInstance = mobjPreviousInstance
End Property

Public Property Get Instance(ByVal lngHwnd As Long) As clsInstance
Attribute Instance.VB_UserMemId = 0
    On Error Resume Next
    Set Instance = mcolInstances("_" & lngHwnd)
End Property

Public Property Get InstanceCount() As Long
    InstanceCount = mcolInstances.Count
End Property

Public Sub RemoveInstance(ByVal lngHwnd As Long)
    On Error Resume Next
    Dim lngInstanceCount    As Long
    Dim lngPtr              As Long
    Dim objInstance         As clsInstance
    mcolInstances.Remove "_" & lngHwnd
    lngInstanceCount = mcolInstances.Count
    Set mobjLastInstance = mobjPreviousInstance
    For Each objInstance In mcolInstances
        lngPtr = lngPtr + 1
        If lngPtr = lngInstanceCount Then Exit For
        Set mobjPreviousInstance = objInstance
    Next
End Sub

Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "440"
    Set NewEnum = mcolInstances.[_NewEnum]
End Property

Private Sub Class_Initialize()
    Set mcolInstances = New Collection
End Sub

Private Sub Class_Terminate()
    Set mcolInstances = Nothing
End Sub
